# -*- coding: utf-8 -*-
import copy

from amplify.agent import CommonDataTank, CommonDataClient
from amplify import __version__

__author__ = "Mike Belov"
__copyright__ = "Copyright (C) 2015, Nginx Inc. All rights reserved."
__credits__ = ["Mike Belov", "Andrei Belov", "Ivan Poluyanov", "Oleg Mamontov", "Andrew Alexeev"]
__license__ = ""
__maintainer__ = "Mike Belov"
__email__ = "dedm@nginx.com"


class ConfigdContainer(CommonDataTank):
    pass


class ConfigdClient(CommonDataClient):

    def config(self, payload, checksum):
        self.current = {
            'data': payload,
            'checksum': checksum,
        }

    def flush(self):
        if not self.current:
            return

        delivery = copy.deepcopy(self.current)
        self.current = {}
        return {
            'object': self.object.definition,
            'config': delivery,
            'agent_version': __version__
        }
