# -*- coding: utf-8 -*-
import copy

from collections import defaultdict

from amplify import __version__
from amplify.agent import CommonDataTank, CommonDataClient


__author__ = "Mike Belov"
__copyright__ = "Copyright (C) 2015, Nginx Inc. All rights reserved."
__credits__ = ["Mike Belov", "Andrei Belov", "Ivan Poluyanov", "Oleg Mamontov", "Andrew Alexeev"]
__license__ = ""
__maintainer__ = "Mike Belov"
__email__ = "dedm@nginx.com"


class MetadContainer(CommonDataTank):
    pass

class MetadClient(CommonDataClient):

    def meta(self, data):
        self.current = data

    def flush(self):
        if self.current:
            delivery = copy.deepcopy(self.current)
            self.current = defaultdict(dict)
            return {
                'object': self.object.definition,
                'meta': delivery,
                'agent_version': __version__
            }
